<script>
export default {
  name: "AppStoreMonitor",
  label: "市场看板-门店运营监控表",
  data() {
    return {
      tableData: [],
      columns: [
        {label: "课区", prop: "groupName"},
        {label: "课长", prop: "supervisorName"},
        {label: "门店", prop: "storeName"},
        {label: "门店现烤净收货额", prop: "bakeNetAmt"},
        {label: "门店现烤销售额", prop: "bakeSaleAmt"},
        {label: "门店现烤报损额", prop: "bakeBsAmt"},
        {label: "门店现烤领用额", prop: "bakeLyAmt"},
        {label: "门店现烤惜食", prop: "bakeXsSaleAmt"},
      ],
      filter: "",
      summary: {}
    }
  },
  computed: {
    search: v => v.$marketBoard.search,
    list: v => v.tableData.filter(e => !v.filter || e.supervisorName == v.filter) || [],
    options: v => [...new Set(v.tableData.map(e => e.supervisorName))],
    tableConfig: v => {
      return {
        headerBGC: 'rgba(13, 48, 99, 0.6)',
        // headerBGC: '#003B51',
        oddRowBGC: window.evenRowBGC(), evenRowBGC: "transparent",
        header: v.columns.map(e => e.label),
        columnWidth: v.columns.map(e => e.width || "0;flex:1;min-width:0;"),
        align: v.columns.map(e => e.align || "left"),
        data: v.list.map(e => v.columns.map(column => e[column.prop])),
      }
    },
    summaryRow: v => v.columns.map((column, i) => {
      const isNumber = v => /^-?\d+(\.\d+)?%?$/.test(v)
      const style = {textAlign: column.align}
      if (column.width > 0) {
        style.width = `${column.width}px`
      } else {
        style.flex = 1
        style.minWidth = 0
      }
      return {
        style,
        value: isNumber(v.summary[column.prop]) ? v.summary[column.prop] :
            i == 0 ? v.summary.groupName : ""
      }
    })
  },
  methods: {
    getTableData() {
      const {$http, $waitFor} = window
      $waitFor($http).then(() => $http.post("/data-boot/la/screen/marketBoard/storeMonitor", {
        ...this.search, limit: 999
      })).then(res => {
        if (res?.data) {
          this.summary = res.data.total
          this.tableData = res.data?.page?.records || []
        }
      })
    }
  },
  watch: {
    search: {
      immediate: true, deep: true, handler() {
        this.getTableData()
      }
    }
  }
}
</script>

<template>
  <section class="AppStoreMonitor">
    <div class="flex" style="margin-bottom: 22px">
      <div class="fill"/>
      <el-select placeholder="全部" v-model="filter" size="small" clearable class="AppSelect">
        <el-option v-for="(name,i) in options" :key="i" :label="name" :value="name"/>
      </el-select>
    </div>
    <scroll-table :table-data="tableData" :columns="columns"/>
    <!--<dv-scroll-board :config="tableConfig"/>-->
    <div class="summary flex">
      <div class="item" v-for="(col,i) in summaryRow" :key="i" v-text="col.value" :style="col.style"/>
    </div>
  </section>
</template>

<style>
.AppStoreMonitor {
  flex-shrink: 0 !important;
  color: #fff;
  box-sizing: border-box;
  width: 660px;
}

.AppStoreMonitor .dv-scroll-board,.AppStoreMonitor .scrollTable{
  height: calc(100% - 30px - 55px) !important;
}

.AppStoreMonitor .el-select {
  width: 120px;
}
</style>
